void x64toaKAZE (      /* stdcall is faster and smaller... Might as well use it for the helper. */
        unsigned long long val,
        char *buf,
        unsigned radix,
        int is_neg
        )
{
        char *p;                /* pointer to traverse string */
        char *firstdig;         /* pointer to first digit */
        char temp;              /* temp char */
        unsigned digval;        /* value of digit */

        p = buf;

        if ( is_neg )
        {
            *p++ = '-';         /* negative, so output '-' and negate */
            val = (unsigned long long)(-(long long)val);
        }

        firstdig = p;           /* save pointer to first digit */

        do {
            digval = (unsigned) (val % radix);
            val /= radix;       /* get next digit */

            /* convert to ascii and store */
            if (digval > 9)
                *p++ = (char) (digval - 10 + 'a');  /* a letter */
            else
                *p++ = (char) (digval + '0');       /* a digit */
        } while (val > 0);

        /* We now have the digit of the number in the buffer, but in reverse
           order.  Thus we reverse them now. */

        *p-- = '\0';            /* terminate string; p points to last digit */

        do {
            temp = *p;
            *p = *firstdig;
            *firstdig = temp;   /* swap *p and *firstdig */
            --p;
            ++firstdig;         /* advance to next two digits */
        } while (firstdig < p); /* repeat until halfway */
}

/* Actual functions just call conversion helper with neg flag set correctly,
   and return pointer to buffer. */

char * _i64toaKAZE (
        long long val,
        char *buf,
        int radix
        )
{
        x64toaKAZE((unsigned long long)val, buf, radix, (radix == 10 && val < 0));
        return buf;
}

char * _ui64toaKAZE (
        unsigned long long val,
        char *buf,
        int radix
        )
{
        x64toaKAZE(val, buf, radix, 0);
        return buf;
}

char * _ui64toaKAZEzerocomma (
        unsigned long long val,
        char *buf,
        int radix
        )
{
                        char *p;
                        char temp;
                        int txpman;
                        int pxnman;
        x64toaKAZE(val, buf, radix, 0);
                        p = buf;
                        do {
                        } while (*++p != '\0');
                        p--; // p points to last digit
                             // buf points to first digit
                        buf[26] = 0;
                        txpman = 1;
                        pxnman = 0;
                        do
                        { if (buf <= p)
                          { temp = *p;
                            buf[26-txpman] = temp; pxnman++;
                            p--;
                            if (pxnman % 3 == 0)
                            { txpman++;
                              buf[26-txpman] = (char) (',');
                            }
                          }
                          else
                          { buf[26-txpman] = (char) ('0'); pxnman++;
                            if (pxnman % 3 == 0)
                            { txpman++;
                              buf[26-txpman] = (char) (',');
                            }
                          }
                          txpman++;
                        } while (txpman <= 26);
        return buf;
}

char * _ui64toaKAZEcomma (
        unsigned long long val,
        char *buf,
        int radix
        )
{
                        char *p;
                        char temp;
                        int txpman;
                        int pxnman;
        x64toaKAZE(val, buf, radix, 0);
                        p = buf;
                        do {
                        } while (*++p != '\0');
                        p--; // p points to last digit
                             // buf points to first digit
                        buf[26] = 0;
                        txpman = 1;
                        pxnman = 0;
                        while (buf <= p)
                        { temp = *p;
                          buf[26-txpman] = temp; pxnman++;
                          p--;
                          if (pxnman % 3 == 0 && buf <= p)
                          { txpman++;
                            buf[26-txpman] = (char) (',');
                          }
                          txpman++;
                        } 
        return buf+26-(txpman-1);
}

// Modified C Code by Kaze, original C Code by Kurt White.

// Can a knight placed on a chess board and jump to all 63 remaining squares
// only landing on each square once?
// Lets find out :)

#include <stdio.h>
#include <stdlib.h>

#include <time.h>

clock_t start,finish;
double duration;

/* List of valid moves a knight can make from any square */
int list[65][9] = { 0,0,0,0,0,0,0,0,0,
                                        11,18,0,0,0,0,0,0,0,    //1
                                        17,12,19,0,0,0,0,0,0,   //2
                                        9,13,18,20,0,0,0,0,0,   //3
                                        10,14,19,21,0,0,0,0,0,  //4
                                        15,11,20,22,0,0,0,0,0,  //5
                                        16,12,23,21,0,0,0,0,0,  //6
                                        24,13,22,0,0,0,0,0,0,   //7
                                        14,23,0,0,0,0,0,0,0,    //8
                                        3,26,19,0,0,0,0,0,0,    //9
                                        4,25,20,27,0,0,0,0,0,   //10
                                        1,5,17,26,21,28,0,0,0,  //11
                                        2,6,18,22,27,29,0,0,0,  //12
                                        7,3,23,19,28,30,0,0,0,  //13
                                        8,4,24,31,20,29,0,0,0,  //14
                                        5,32,21,30,0,0,0,0,0,   //15
                                        6,31,22,0,0,0,0,0,0,    //16
                                        2,11,34,27,0,0,0,0,0,   //17
                                        1,3,33,12,28,35,0,0,0,  //18
                                        2,9,4,25,13,34,29,36,0, //19
                                        3,5,10,14,26,30,35,37,0,//20
                                        4,6,15,11,31,27,36,38,0,//21
                                        7,16,5,32,12,39,28,37,0,//22
                                        8,6,40,13,29,38,0,0,0,  //23
                                        7,14,39,30,0,0,0,0,0,   //24
                                        10,42,19,35,0,0,0,0,0,  //25
                                        9,41,11,20,36,43,0,0,0, //26
                                        10,17,33,12,42,21,37,44,0, //27
                                        11,13,18,34,22,38,43,45,0, //28
                                        12,14,23,39,19,35,44,46,0, //29
                                        15,24,40,13,47,20,36,45,0, //30
                                        16,48,14,21,37,46,0,0,0,   //31
                                        15,47,22,38,0,0,0,0,0,  //32
                                        50,18,27,43,0,0,0,0,0,  //33
                                        49,17,51,19,28,44,0,0,0, //34
                                        25,41,50,52,18,20,29,45,0, //35
                                        26,42,51,53,19,21,30,46,0, //36
                                        31,47,52,54,20,22,27,43,0, //37
                                        32,48,55,53,23,21,28,44,0, //38
                                        56,24,54,22,29,45,0,0,0, //39
                                        55,23,30,46,0,0,0,0,0,  //40
                                        58,26,51,35,0,0,0,0,0,  //41
                                        57,25,59,52,27,36,0,0,0, //42
                                        49,58,33,60,26,53,28,37,0, //43
                                        59,61,50,54,34,27,29,38,0, //44
                                        60,62,55,39,51,28,30,35,0, //45
                                        63,56,61,40,52,31,29,36,0, //46
                                        64,62,32,53,30,37,0,0,0, //47
                                        63,31,54,38,0,0,0,0,0,  //48
                                        59,34,43,0,0,0,0,0,0,   //49
                                        33,60,35,44,0,0,0,0,0,  //50
                                        57,61,41,34,36,45,0,0,0, //51
                                        58,62,42,35,37,46,0,0,0, //52
                                        63,59,47,36,38,43,0,0,0, //53
                                        64,48,60,39,37,44,0,0,0, //54
                                        40,61,38,45,0,0,0,0,0,  //55
                                        62,39,46,0,0,0,0,0,0,   //56
                                        42,51,0,0,0,0,0,0,0,    //57
                                        41,52,43,0,0,0,0,0,0,   //58
                                        49,42,53,44,0,0,0,0,0,  //59
                                        50,54,43,45,0,0,0,0,0,  //60
                                        55,51,44,46,0,0,0,0,0,  //61
                                        56,47,52,45,0,0,0,0,0,  //62
                                        48,53,46,0,0,0,0,0,0,   //63
                                        47,54,0,0,0,0,0,0,0     //64
};

//     1  2  3  4  5  6  7  8
// 0: 02 03 04 04 04 04 03 02
// 1: 03 04 06 06 06 06 04 03
// 2: 04 06 08 08 08 08 06 04
// 3: 04 06 08 08 08 08 06 04
// 4: 04 06 08 08 08 08 06 04
// 5: 04 06 08 08 08 08 06 04
// 6: 03 04 06 06 06 06 04 03
// 7: 02 03 04 04 04 04 03 02

void play( int );
void winner( void );

int board[65] = {0}; /* the Chess board   */
int moves[65];       /* list of moves     */
int k = 0;           /* move counter      */
  char llTOaDigits[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
  char llTOaDigits2[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
  unsigned long long wincount = 0;
  unsigned long long Sequences = 0, Jumps = 0;
  int Verbose=0;
  #define KAZE_toupper(c) ( (((c) >= 'a') && ((c) <= 'z')) ? ((c) - 'a' + 'A') : (c) )
  char Bunyo1, Bunyo2;

void main(int argc, char *argv[])
{
           printf("Knight-tour.exe, revision 7.\n");
           printf("Purpose: Can a knight placed on a chess board and jump to all 63 remaining\n");
           printf("         squares only landing on each square once? Let's find out.\n");
 
   if (argc < 2)
   {
           printf("Usage: Knight-tour square [V|F]\n");
           printf("       square represents a board position, as A1(bottom-left), H8(top-right);\n");
           printf("       V and F are optional parameters for verbose output;\n");
           printf("       V lists 'Tours Sequences' & progress bar;\n");
           printf("       F lists 'Attempts Sequences' i.e. TOUR sequences and FAILURE sequences\n");
           printf("       i.e. moves from start position till either 64th or dead-end position.\n");
           printf("Note1: Modified C Code by Kaze, original C Code by Kurt White.\n");
           printf("Note2: An amateurish program. Anyway, whatever!\n");
           printf("Note3: It is useful to redirect output to a file for studying, benchmarking.\n");
           printf("Note4: When not using Warnsdorf's heuristic A8 first tour appeared after\n");
           printf("       17,739,768 recursive calls(knight's moves), it is:\n");
           printf("       A8C7E8G7E6D8B7D6C8A7C6B8D7F8H7F6G8E7G6H8F7H6F5D4B5A3C4B6D5B4A6C5\n");
           printf("       A4B2D3E5G4H2F1E3D1F2H1G3H5F4H3G5E4D2B1C3A2C1E2G1F3H4G2E1C2A1B3A5, for\n");
           printf("       H1 though, first tour didn't appear even after 2,614,840,115,968 calls\n");
           printf("       which took 166470.77 seconds i.e. at rate 15,707,502+ jumps(knight's\n");
           printf("       moves) per second on AMD Barton 2600+(1919MHz).\n");
           printf("Note5: When using Warnsdorf's heuristic A8 first tour appeared after\n");
           printf("       5,909 recursive calls(knight's moves), it is:\n");
           printf("       A8C7E8G7H5G3H1F2H3G1E2C1A2B4A6B8D7F8H7G5F7H8G6H4G2E1C2A1B3A5B7D8\n");
           printf("       C6A7C8E7G8H6G4H2F1D2B1A3B5D6F5D4F3E5C4B2D3F4E6C5A4B6D5F6E4C3D1E3, for\n");
           printf("       H1, first tour appeared after 497 calls(245 dead-end sequences), it is:\n");
           printf("       H1G3F1H2G4H6G8E7C8A7B5A3B1D2B3A1C2E1G2H4G6H8F7D8B7A5C6B8A6C7A8B6\n");
           printf("       A4B2D1F2H3G1E2C1A2B4D5F6H7F8D7C5E6G5F3D4F5E3C4E5D3F4H5G7E8D6E4C3.\n");
           printf("Example: D:\\>Knight-tour b4 v\n");
	   return;
   }
//if (atoi(argv[1]) < 1) return;
//if (atoi(argv[1]) > 64) return;
// Square takes values from 1 to 64
// 1:top-left, 57:bottom-left, 8:top-right, 64:bottom-right

Bunyo1=*(argv[1]+1);
if (Bunyo1 < '1' || Bunyo1 > '8') {printf("Knight-tour: Incorrect board position!\n"); return;}
Bunyo2=KAZE_toupper(*(argv[1]+0));
if (Bunyo2 < 'A' || Bunyo2 > 'H') {printf("Knight-tour: Incorrect board position!\n"); return;}

   if (argc == 3)
   {
          if (KAZE_toupper(*argv[2]) == 'V') Verbose=1;
          if (KAZE_toupper(*argv[2]) == 'F') Verbose=2;
   }

printf("\n");
printf("PUBLIC  _play                                                      \n");
printf("; Function compile flags: /Ogty                                    \n");
printf("_TEXT   SEGMENT                                                    \n");
printf("_square$ = 8                                            ; size = 4 \n");
printf("_play   PROC NEAR                                                  \n");
printf("                                                                   \n");
printf("{                                                                  \n");
printf("   board[square] = 1;                                              \n");
printf("   moves[k++] = square;                                            \n");
printf("                                                                   \n");
printf("        mov     eax, DWORD PTR _k                                  \n");
printf("        push    edi                                                \n");
printf("        mov     edi, DWORD PTR _square$[esp]                       \n");
printf("        mov     DWORD PTR _moves[eax*4], edi                       \n");
printf("        inc     eax                                                \n");
printf("                                                                   \n");
printf("   if (k == 64)                                                    \n");
printf("   {                                                               \n");
printf("      board[square] = 0; k--; return;                              \n");
printf("   }                                                               \n");
printf("                                                                   \n");
printf("        cmp     eax, 64                                 ; 00000040H\n");
printf("        mov     DWORD PTR _board[edi*4], 1                         \n");
printf("        mov     DWORD PTR _k, eax                                  \n");
printf("        jne     SHORT $L1327                                       \n");
printf("        mov     DWORD PTR _board[edi*4], 0                         \n");
printf("        mov     DWORD PTR _k, 63                        ; 0000003fH\n");
printf("        pop     edi                                                \n");
printf("        ret     0                                                  \n");
printf("$L1327:                                                            \n");
printf("                                                                   \n");
printf("   for (i = 0; list[square][i] != 0; i++)                          \n");
printf("   {                                                               \n");
printf("                                                                   \n");
printf("        lea     eax, DWORD PTR [edi+edi*8]                         \n");
printf("        mov     ecx, DWORD PTR _list[eax*4]                        \n");
printf("        test    ecx, ecx                                           \n");
printf("        lea     eax, DWORD PTR _list[eax*4]                        \n");
printf("        je      SHORT $L1330                                       \n");
printf("        push    esi                                                \n");
printf("        lea     esi, DWORD PTR [edi+edi*8]                         \n");
printf("        lea     esi, DWORD PTR _list[esi*4]                        \n");
printf("        npad    2                                                  \n");
printf("$L1328:                                                            \n");
printf("                                                                   \n");
printf("      if (board[list[square][i]] == 0)                             \n");
printf("                                                                   \n");
printf("        mov     eax, DWORD PTR [eax]                               \n");
printf("        mov     ecx, DWORD PTR _board[eax*4]                       \n");
printf("        test    ecx, ecx                                           \n");
printf("        jne     SHORT $L1329                                       \n");
printf("                                                                   \n");
printf("         play(list[square][i]);                                    \n");
printf("   }                                                               \n");
printf("                                                                   \n");
printf("        push    eax                                                \n");
printf("        call    _play                                              \n");
printf("        add     esp, 4                                             \n");
printf("$L1329:                                                            \n");
printf("        mov     ecx, DWORD PTR [esi+4]                             \n");
printf("        add     esi, 4                                             \n");
printf("        test    ecx, ecx                                           \n");
printf("        mov     eax, esi                                           \n");
printf("        jne     SHORT $L1328                                       \n");
printf("        pop     esi                                                \n");
printf("$L1330:                                                            \n");
printf("                                                                   \n");
printf("   board[square] = 0; k--; return;                                 \n");
printf("                                                                   \n");
printf("        mov     eax, DWORD PTR _k                                  \n");
printf("        dec     eax                                                \n");
printf("        mov     DWORD PTR _board[edi*4], 0                         \n");
printf("        mov     DWORD PTR _k, eax                                  \n");
printf("        pop     edi                                                \n");
printf("                                                                   \n");
printf("}                                                                  \n");
printf("                                                                   \n");
printf("        ret     0                                                  \n");
printf("_play   ENDP                                                       \n");
printf("_TEXT   ENDS                                                       \n");
printf("\n");

                        start = clock();

   printf("Above code is being executed, recursive exhaustive depth-first searching ...\n");
   if (Verbose==1) printf("|Sequences(only failures):  |Jumps i.e. knight's moves: |Elapsed seconds:\n");

   // 1 2 3 ... 8   a8 b8 ... h8
   // 9 ...         a7 ...
   // ...      64   ...       h1
   play( (Bunyo2-'A') + (8-(Bunyo1-'1'+1))*8 + 1 );
   printf("\n");
   printf("Total recursions(jumps i.e. knight's moves): %I64d\n", Jumps);
   printf("Total solutions(tours): %I64d\n", wincount);
}

//char BarIndicator[65]; 
unsigned long nTrys_High = 0, nTrys_Low = 0;

void play( int square )
{
  int i;

  Jumps++;
  // nTrys_Low++; if (nTrys_Low == 0) nTrys_High++;

   board[square] = 1;
   moves[k++] = square;

             //for (i=1; i<65;i++) if (i-k>0) BarIndicator[i]=' '; else BarIndicator[i]='#';
             //printf(" [%s]\n", &BarIndicator[1]);

if ((++nTrys_Low & 0x0FFFFFFF) == 0x0FFFFFFF) { // 4x 16 millions
                        finish = clock();
                        duration = (double) (finish - start) / CLOCKS_PER_SEC;
             if (Verbose==1) printf("|%s |%s |%.2f \r", _ui64toaKAZEzerocomma(Sequences, llTOaDigits, 10)+(26-26), _ui64toaKAZEzerocomma(Jumps, llTOaDigits2, 10)+(26-26), duration);
                               }

   if (k == 64)
   {
             wincount++;
                        finish = clock();
                        duration = (double) (finish - start) / CLOCKS_PER_SEC;
             if (Verbose==1) printf("|%s |%s |%.2f \r", _ui64toaKAZEzerocomma(Sequences, llTOaDigits, 10)+(26-26), _ui64toaKAZEzerocomma(Jumps, llTOaDigits2, 10)+(26-26), duration);
             if (Verbose==1) winner();
             if (Verbose==2) winner();
      board[square] = 0; k--; return;
   }
   for (i = 0; list[square][i] != 0; i++)
   {
      if (board[list[square][i]] == 0)
         play(list[square][i]);
      else
         if (list[square][i+1] == 0)
         {
         Sequences++;
         if (Verbose==2) winner();
         }
   }
   board[square] = 0; k--; return;
}

void winner( void )
{
   int i;

     printf("\n");
     for (i = 0; i < k; i++) {
         printf( "%c%d", 'A'+( (moves[i]-1)%8+1 )-1, 9-( (moves[i]-1)/8+1 ) );
         //if ( (i+1)%8==0 ) printf("\n");
     }
     printf("\n");
   if (Verbose==1) printf("|Sequences(only failures):  |Jumps i.e. knight's moves: |Elapsed seconds:\n");

}
